﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.Serialization; // Serialization
using System.Runtime.Serialization.Formatters.Binary; // Serialization
using System.IO; // Needed for IO 

namespace WindowsFormsApplication55
{
    public partial class Form1 : Form
    {
        List<Customer> custs = new List<Customer>();
        BindingSource listSource = new BindingSource();
        BindingSource gridSource = new BindingSource();


        public Form1()
        {
            InitializeComponent();
            this.AutoSize = true;
            this.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            listBox1.DataSource = listSource;
            dataGridView1.DataSource = gridSource;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked == true)
            {
                panel1.Show();
            }
            else
            {
                panel1.Hide();
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            try
            {
                Customer c = new Customer(
                    custBox.Text,
                    int.Parse(creditBox.Text)
                    );
                custs.Add(c);
                updateViews();
            }
            catch (Exception ex)
            {

            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            try
            {
                custs.RemoveAt(listBox1.SelectedIndex);
                //custs.RemoveAt(custs.Count-1);
                updateViews();
            }
            catch (Exception ex)
            {
                
            }
        }

        private void updateViews()
        {
            listSource.DataSource =
                custs.Select(x => x.name + " " + x.credit);
            listSource.ResetBindings(true);

            gridSource.DataSource =
                custs.Select(
                x => new { Name = x.name, Credit = x.credit, Date = DateTime.Now }
                );
            gridSource.ResetBindings(true);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd = new SaveFileDialog();
            if(fd.ShowDialog() == DialogResult.OK){
                save(fd.FileName);
            }
        }

        private void save(String FileName)
        {
            IFormatter myformatter = new BinaryFormatter();
            using (FileStream myfile = File.Create(FileName)){
                foreach (Customer c in custs)
                {
                    myformatter.Serialize(myfile, c);
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {


            OpenFileDialog fd = new OpenFileDialog();
            if(fd.ShowDialog() == DialogResult.OK){
                custs.Clear();
                load(fd.FileName);
                updateViews();
            }
        }

        private void load(String FileName)
        {
             IFormatter myformatter = new BinaryFormatter();
             using (FileStream myfile = File.OpenRead(FileName))
             {
                 while (myfile.Position != myfile.Length)
                 {
                     Customer c = myformatter.Deserialize(myfile) as Customer;
                     custs.Add(c);
                 }
             }
        }

    }
}
